<template>
  <span :id="id" :name="field.name+'_show'" class="component-input-span o-select-control" :style="{display:((field.displayType == Constant.PermissionType_HIDDEN || field.textType == 'hidden') && !field.hiddenValue)?'':'inline-block'}">
    <template
      v-if="field.displayType == Constant.PermissionType_HIDDEN || field.textType.toLowerCase() == 'hidden'"
    >
      <!-- 隐藏 TODO:注意，隐藏时不应该有hidden的field存在，有安全问题，以后要改过来：Jarod -->
      <!-- <span>{{field.hiddenValue}}</span> -->
      <div class="select" v-if="field.mobile&&field.hiddenValue">
        <mt-cell :title="field.discript?field.discript:field.name" >
          <span>{{field.hiddenValue}}</span>
        </mt-cell>
      </div>
    </template>

    <!--只读-->
    <template v-else-if="field.textType.toLowerCase() == 'readonly' || field.displayType == Constant.PermissionType_READONLY || field.displayType == Constant.PermissionType_DISABLED">
      <!-- 只读（文本模式） -->
      <template v-if="field.readOnlyShowValOnly">
        <!-- <template>{{field.value}}</template> -->

        <template>
          <div class="select" v-if="field.mobile">
            <mt-cell :title="field.discript?field.discript:field.name">
                <span>{{field.impressionVal}}</span>
            </mt-cell>
          </div>
        </template>

      </template>
      <!-- 只读（控件模式） -->
      <template v-else>
        <div class="select" v-if="field.mobile">
          <mt-cell :title="field.discript?field.discript:field.name" is-link>
              <span>{{field.impressionVal?field.impressionVal: $t('please_choose')}}</span>
          </mt-cell>
        </div>
        <mt-popup v-model="popupVisible" position="bottom" width="100%">
          <mt-picker 
            :slots="field.slots" 
            :show-toolbar="true"  
            ref="picker" 
            value-key="value"
          >
            <div class="btns-wrap">
              <span @click="handleCancel">{{$t('cancel')}}</span>
              <span @click="handleConfirm">{{$t('verify')}}</span>
            </div>
            
          </mt-picker>
        </mt-popup>
      </template>
    </template>
    
    <template v-else-if="field.displayType == Constant.PermissionType_MODIFY">
      <!-- 可编辑 -->
      <div class="tree-wrap" v-if="field.mobile && field.layout == 'vertical'">
        <div class="tree-vertical" @click="showDialog">
          <div class="select" >
            <span>{{field.discript?field.discript:field.name}}</span>
            <span>
              {{$t('please_choose')}}
              <i class="fa fa-angle-right fa-lg"></i>
            </span>
          </div>
          <div class="select-data" v-if="field.impressionVal">
            {{field.impressionVal?field.impressionVal: $t('please_choose')}}
          </div>
        </div>
      </div>
      <div 
        class="select" 
        :class="{textareaCheck: isActive }" 
        @click="showDialog" 
        v-else-if="field.mobile"
      >
        <a class="mint-cell">
          <span class="mint-cell-mask"></span> 
          <div class="mint-cell-left"></div> 
          <div class="mint-cell-wrapper" :class="{ textCheck: isActive }">
            <div class="mint-cell-title">
              <!----> 
              <span class="mint-cell-text">
                {{field.discript?field.discript:field.name}}
                <span style="color:red" v-if="field.essential || field.instantValidate || (field.validateLibs && field.validateLibs.indexOf('checkEmpty_system') > 0)">*</span>
              </span> 
              <!---->
            </div> 
            <div class="mint-cell-value is-link">
              <span>{{field.impressionVal?field.impressionVal: $t('please_choose')}}</span>
            </div> 
            <i class="mint-cell-allow-right"></i>
          </div> 
          <div class="mint-cell-right"></div>
        </a>
        <div class="tips" v-show="isActive">
          {{errorMessage}}
        </div>
      </div>
      <!-- <van-action-sheet 
        class="o-select-vant-popup"
        v-model="popupVisible" 
        :title="field.discript?field.discript:field.name" 
        cancel-text="确定"
        :closeable="false"
        @cancel="handleConfirm"
        >
        <div 
          class="content" 
          v-for="(item,index) in field.options" :key="index"
          @click.stop.prevent="handleClick(item, index)"
        >
          {{item.option}}
          <van-icon name="success" class="icon" v-if="item.isSelected" /></div>
      </van-action-sheet> -->

      <van-popup 
        class="o-select-van-popup"
        v-model="popupVisible" 
        round 
        position="bottom" 
        :style="{ 'height': popupHeight, 'min-height':'30%' }"
        get-container="body"
      >
        <div class="container">
          <div class="header">
            <van-icon name="cross" @click="popupVisible = false"/>
          </div>
          <div class="content-box" :class="[!field.multiSelect?'content-box-multi':'','content-box']">
            <div 
              class="content" 
              v-for="(item,index) in field.options" :key="index"
              @click.stop.prevent="handleClick(item, index)"
            >
              {{item.option}}
              <van-icon name="success" class="icon" v-if="item.isSelected" />
            </div>
          </div>
          <div class="dividing-line" v-if="field.multiSelect"></div>
          <div class="bottom-btn" @click.stop.prevent="handleConfirm" v-if="field.multiSelect">确 定</div>
        </div>
      </van-popup>
      <!-- <mt-popup v-model="popupVisible" position="bottom" width="100%">
        <mt-picker 
          :slots="field.slots" 
          :show-toolbar="true"  
          ref="picker" 
          value-key="option"
        >
          <div class="btns-wrap">
            <span @click="handleCancel">{{$t('cancel')}}</span>
            <span @click="handleConfirm">{{$t('verify')}}</span>
          </div>
        </mt-picker>
      </mt-popup> -->
    </template>
  </span>
</template>

<script>
import Constant from "@/Constant.js"
import controlHidden from "@/assets/js/controlHidden.js"
export default {
  name: "o-select",
  props: ["id"],
  computed: {
    field: function() {
      let allData = this.$parent.findField(this.id);
      if(allData.discript) {//识别控件描述最后一个字符为*时，*变红
        if(allData.discript.charAt(allData.discript.length - 1) == "*") {
          allData.discript = allData.discript.replace(/(\s|\*)+$/g, '');
          allData.essential = true;
        }
      }
      if(allData.options.length == 1) {
        if(allData.options[0].option == ' ' && allData.options[0].value == ' ') {
          allData.value = '';
          allData.impressionVal = '';
        }
      }
      // let slot = [];
      if(allData.options && allData.options.length > 0) {
        for(let i=0; i<allData.options.length; i++) {
          if(!allData.options[i].option) {
            allData.options[i].option = " ";
          }
          if(!allData.options[i].value) {
            allData.options[i].value = " ";
          }
        }
      }

      if(allData.multiSelect) {
        let valArray = allData.value.split(";");
        let mt = '';
        if(valArray && valArray.length > 0) {
          for(let i=0; i<valArray.length; i++) {
            for(let j=0; j<allData.options.length; j++) {
              if(valArray[i] == allData.options[j].value) {
                mt += allData.options[j].option + ';';
              }
            }
          }
        }
      
        allData.impressionVal = mt.replace(/^(\s|;)+|(\s|;)+$/g, "");

        for(let i = 0; i < allData.options.length; i++) {
          if(!allData.value) {
            if(allData.options[i].def == true) {
              allData.value = allData.options[i].value;
              allData.impressionVal = allData.options[i].option;
            }
          }
        }
      }else {
        for(let i = 0; i < allData.options.length; i++) {
          if(allData.value == allData.options[i].value) {
            allData.impressionVal = allData.options[i].option;
          }
          if(!allData.value) {
            if(allData.options[i].def == true) {
              allData.value = allData.options[i].value;
              allData.impressionVal = allData.options[i].option;
            }
          }
        }
      }      
      // let value = {
      //   values: allData.options
      // }; 
      // slot.push(value);
      // allData.slots = slot;
      return allData;
    }
  },
  watch:{
    // field(newV,oldV){ //下拉框联动时需要监听每一次值改变，判断是否要刷新
    //   let field = this.field;
    //   if(field.refreshMode && field.refreshMode == 1) {
    //     if(newV.value != oldV.value) {
    //       let havePar = false;
    //       let par  = '';
    //       while(!havePar) {
    //         par = par + '.$parent';
    //         let url = 'this' + par + '.refresh';
    //         if(eval(url)) {
    //           let path = url + '(' + this.id + ')';
    //           eval(path);
    //           break
    //         }
    //       }
    //     }
    //   }
    //   if(!newV.value) {
    //     field.impressionVal = '';
    //   }
    // },

    'field.value':{ //监听的对象
      deep:true, //深度监听设置为 true
      handler:function(newV,oldV){
        if(this.field.refreshOnChanged){
          let havePar = false;
          let par  = '';
          if(newV !== oldV) {
            while(!havePar) {
              par = par + '.$parent';
              let url = 'this' + par + '.refresh';
              if(eval(url)) {
                let path = url + '(' + "'"+ this.id +"'" + ')';
                eval(path);
                break
              }
            }
          }
        }
        if(!newV) {
          this.field.impressionVal = '';
        }
      }
    }



    // 'field.value':{ //监听的对象
    //   deep:true, //深度监听设置为 true
    //   handler:function(newV,oldV){
    //     if(this.field.refreshMode && this.field.refreshMode == 1) {
    //       if(newV != oldV) {
    //         let havePar = false;
    //         let par  = '';
    //         while(!havePar) {
    //           par = par + '.$parent';
    //           let url = 'this' + par + '.refresh';
    //           if(eval(url)) {
    //             let path = url + '(' + this.id + ')';
    //             eval(path);
    //             break
    //           }
    //         }
    //       }
    //     }else if(this.field.refreshOnChanged){
    //       let havePar = false;
    //       let par  = '';
    //       while(!havePar) {
    //         par = par + '.$parent';
    //         let url = 'this' + par + '.refresh';
    //         if(eval(url)) {
    //           let path = url + '(' + "'"+ this.id +"'" + ')';
    //           eval(path);
    //           break
    //         }
    //       }
    //     }
    //     if(!newV) {
    //       this.field.impressionVal = '';
    //     }
    //   }
    // }
  },
  mounted(){
    this.$nextTick(()=>{
      let field = this.field;
      if(field.isHideType) {
        let id = this.id,
          formShowType = field.formShowType;
        controlHidden({id, field, formShowType})
      }
    })
  },
  data: function() {
    return { 
      isNeedToRefresh:false,
      Constant, 
      selectedOption: {},
      popupVisible: false,
      currentTags: {},
      isActive:false,
      errorMessage:'',
      popupHeight:'',
    };
  },
  methods: {
    showDialog() {
      let field = this.field;
      let pH = document.body.clientHeight;
      let _ops = field.options;
      let _ch = '';
      if(field.multiSelect) {
        _ch = (_ops.length * 40) + 104;
      }else {
        _ch = (_ops.length * 40) + 48;
      }
      let h = Math.ceil((_ch / pH) * 100);
      if(h > 80) {
        this.popupHeight = 80 + '%'
      }else if(h < 30) {
        this.popupHeight = 30 + '%'
      }else {
        this.popupHeight = h + '%'
      }
      this.popupVisible = true;
    },

    handleCancel() {
      this.popupVisible = false;
    },

    handleClick(item){
      let field = this.field;
      if(field.multiSelect) { //多选
        item.isSelected = !item.isSelected;
        this.$forceUpdate();
      }else {
        field.value = item.value;
        field.impressionVal = item.option;
        this.handleConfirm();
      }
      
    },

    handleConfirm () {
      let field = this.field;
      if(field.multiSelect) { //多选
        let _ops = field.options;
        let val = '',
            op = '';
        _ops.forEach(item => {
          if(item.isSelected) {
            val += item.value + ";";
            op += item.option + ";";
          }
        })
        field.value = val.replace(/^(\s|;)+|(\s|;)+$/g, '');
        field.impressionVal = op.replace(/^(\s|;)+|(\s|;)+$/g, '');
      }
      this.popupVisible = false
      // this.field.value = this.$refs.picker.getValues()[0].value;
      // this.field.impressionVal = this.$refs.picker.getValues()[0].option
      if(field.instantValidate) {
        this.isFieldClear = false;
        let value = true;
        let formData = this.$parent.checkData(value);
        this.$api.formValidation(
          this.$root.appid, 
          formData,
          {
            onSucess: response => {
              if(response.data.errcode == 4001) {
                if(response.data.errors && response.data.errors.length > 0) {
                  let arr = response.data.errors;
                  for(let i=0; i<arr.length; i++) {
                    if(this.field.name == arr[i].field) {
                      this.isActive = true;
                      this.errorMessage = arr[i].errmsg
                      return;
                    }else {
                      this.isActive = false;
                      this.errorMessage = '';
                    }
                  }
                }
              }else if(response.data.errcode == 0) {
                this.isActive = false;
              }
            }
          }
        )
      } 
   
      if (this.field.refreshOnChanged) {//判断是否需要刷新
        let havePar = false;
        let par  = '';
        while(!havePar) {
          par = par + '.$parent';
          let url = 'this' + par + '.refresh';
          if(eval(url)) {
            let path = url + '(' + this.id + ')';
            eval(path);
            break
          }
        }
      }
    },
  },
};
</script>